<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\{Lenses, PreviouslyOwnedLenses};
use Doctrine\ORM\EntityRepository;

class LensesRepository extends EntityRepository
{
	use AcquireTrait;

	/**
	 * @param Lenses $currentRecord
	 */
	public function deacquire(Lenses $currentRecord): void
	{
		$currentRecord->setFormerlyOwned(true)
			->setReceived(true);

		$this->moveRecord($currentRecord, new PreviouslyOwnedLenses());
	}

	/**
	 * @param PreviouslyOwnedLenses $currentRecord
	 */
	public function reacquire(PreviouslyOwnedLenses $currentRecord): void
	{
		$currentRecord->setFormerlyOwned(false);

		$this->moveRecord($currentRecord, new Lenses());
	}
}
